<?php

//--------------------------------------------------

namespace Bbg\ProductAssets\Collection;

//--------------------------------------------------

use Bbg\ProductAssets\CDN\AbstractCDN;
use Bbg\ProductAssets\Entity\AbstractEntity;

//--------------------------------------------------

abstract class AbstractCollection implements \Countable, \Iterator
{

//--------------------------------------------------
// Public:Propertys


//--------------------------------------------------
// Private:Propertys
    private $position = 0;
    private $array = array();
    private $path;
    private $cdn;

//--------------------------------------------------
// Constants


//--------------------------------------------------
    /**
     * No Information Found
     * @since 1.0
     */
    final public function add(AbstractEntity $entity): void
    {
        array_push($this->array, $entity);
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    final public function first(): mixed
    {
        return ($this->array[0] ?? null);
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    final public function count(): int
    {
        return count($this->array);
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    final public function rewind(): void
    {
        $this->position = 0;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    final public function current(): mixed
    {
        return $this->array[$this->position];
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    final public function key(): mixed
    {
        return $this->position;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    final public function next(): void
    {
        ++$this->position;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    final public function valid(): bool
    {
        return isset($this->array[$this->position]);
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setCDN(AbstractCDN $cdn): AbstractCollection
    {
        $this->cdn = $cdn;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getCDN(): ?AbstractCDN
    {
        return $this->cdn;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function setPath(string $path): AbstractCollection
    {
        $this->path = $path;

        return $this;
    }

//--------------------------------------------------

    /**
     * No Information Found
     * @since 1.0
     */
    public function getPath(): string
    {
        return $this->path;
    }

//--------------------------------------------------

}

//--------------------------------------------------

?>