<?php

//--------------------------------------------------

require_once __DIR__ . '/../vendor/autoload.php';

//--------------------------------------------------

use Bbg\ProductAssets\Assets\AbstractAssets;
use Bbg\ProductAssets\CDN\DigitalOceanCDN;
use Bbg\ProductAssets\CDN\ImgixCDN;
use Bbg\ProductAssets\Client;


//--------------------------------------------------
// ### CACHE ###

//Client::setCache(new FileCache(3600, [
//	"cacheDir" => __DIR__."/cache", 
//	]));

//--------------------------------------------------
// ### LOAD A PRODUCT ###

$product = Client::getProduct("401159");

//--------------------------------------------------
// ### USE CDN ###

$product
	->setCDN(new DigitalOceanCDN("assets-dev.babor.cloud"));


//--------------------------------------------------
// ### GLOBAL OPERATIONS ###
/*
print_r(array(
	"getAssetObject", 
	$product->getAssetObject(), 
	));

print_r(array(
	"getSku", 
	$product->getSku(), 
	));

print_r(array(
	"getPath", 
	$product->getPath(), 
	));

print_r(array(
	"getJSONCacheDate", 
	$product->getJSONCacheDate(), 
	));

print_r(array(
	"getCDN", 
	$product->getCDN(), 
	));

print_r(array(
	"getCDN/getPath", 
	$product->getCDN()->getPath("/beforeAfter/globals/0/after.jpg"), 
	));
*/
//--------------------------------------------------
// ### BEFORE/AFTER IMAGES ###

print_r(array(
	"hasBeforeAfter", 
	$product->hasBeforeAfter(), 
	));
	
print_r(array(
	"hasLocaleBeforeAfter", 
	$product->hasBeforeAfterLocale(), 
	));

print_r(array(
	"hasLocaleBeforeAfter(de_DE)",
	$product->hasBeforeAfterLocale("de_DE"),
	));

print_r(array(
	"getBeforeAfterLocales", 
	$product->getBeforeAfterLocales(), 
	));

foreach($product->getBeforeAfter('de_DE') as $beforeAfterItem){
	if(is_object($beforeAfterItem)){
		print_r(array(
			"getBeforeUrl",
			$beforeAfterItem->getBeforeUrl(array(
				"fit" => "fill", 
				"fill" => "solid", 
				"w" => "480", 
				"h" => "480", 
				)),
			));
		
		print_r(array(
			"getAfterUrl",
			$beforeAfterItem->getAfterUrl(),
			));
		}
	}

//--------------------------------------------------
// ### PRODUCT IMAGES ###

print_r(array(
	"hasImage", 
	$product->hasImage(), 
	));
	
print_r(array(
	"hasImageLocale", 
	$product->hasImageLocale(), 
	));

print_r(array(
	"hasImageLocale(en_US)", 
	$product->hasImageLocale("en_US"), 
	));

print_r(array(
	"getImageLocales", 
	$product->getImageLocales(), 
	));

print_r(array(
	"hasImageGroup", 
	$product->hasImageGroup(null, "main"), 
	));

print_r(array(
	"getImageGroups", 
	$product->getImageGroups(), 
	));

foreach($product->getImage(AbstractAssets::IMAGE_TYPE_DETAIL) as $imageItem){
	if(is_object($imageItem)){
		print_r(array(
			"***getUrl***", 
			$imageItem->getUrl(array(
				"fit" => "fill", 
				"fill" => "solid", 
				"w" => "480", 
				"h" => "480", 
				)), 
			));
		
		print_r(array(
			"***getOpaque***", 
			$imageItem->getOpaque(), 
			));
		}
	}

foreach($product->getImage(AbstractAssets::IMAGE_TYPE_MAIN) as $imageItem){
    if(is_object($imageItem)){
        print_r(array(
            "***getUrl***",
            $imageItem->getUrl(array(
                "fit" => "fill",
                "fill" => "solid",
                "w" => "480",
                "h" => "480",
            )),
        ));

        print_r(array(
            "***getOpaque***",
            $imageItem->getOpaque(),
        ));
    }
}

//--------------------------------------------------
// ### PRODUCT VIDEOS ###

print_r(array(
	"hasVideo", 
	$product->hasVideo(), 
	));
	
print_r(array(
	"hasVideoLocale", 
	$product->hasVideoLocale(), 
	));

print_r(array(
	"hasVideoLocale(de_DE)", 
	$product->hasVideoLocale("de_DE"), 
	));

print_r(array(
	"getVideoLocales", 
	$product->getVideoLocales(), 
	));

foreach($product->getVideo(AbstractAssets::VIDEO_TYPE_APP, 'de_DE') as $videoItem){
	if(is_object($videoItem)){
		print_r(array(
			"***VIDEOS/getUrl***", 
			$videoItem->getUrl(), 
			));
		
		print_r(array(
			"***VIDEOS/getPoster***",
			$videoItem->getPoster(), 
			));
		}
	}

//--------------------------------------------------
// ### 360° IMAGES ###

$threeHundredSixty = $product->getThreeHundredSixty();

foreach($product->getThreeHundredSixty() as $threeHundredSixty){
	if(is_object($threeHundredSixty)){
		print_r(array(
			"***360/getUrl***", 
			$threeHundredSixty->getUrl(), 
			));
		}
	}

//--------------------------------------------------

?>